<template>

<div>
    <div class="
        flex
        items-center
    ">
        <!-- <IconBase name="arrowRight" class="ml-2" /> -->

        <ButtonColor
            v-bind:color="project.reports.current.thresholds.current[colorName]"
            v-on:click="showPalette = ! showPalette"
        />

        <b>
            <slot></slot>
        </b>
    </div>

    <div
        v-if="showPalette"
        class="
        border-3
        lg:border-4
        border-white
        dark:border-cgray-900
        rounded-lg
        p-2
        lg:p-4
        mt-4
    ">
        <div class="
            flex
            flex-wrap
            justify-between
        ">
            <ButtonColor
                v-bind:key="color.key"
                v-for="color in PALETTE"
                v-bind:color="color"
                v-on:click="
                    project.reports.current.thresholds.current[colorName] = color;
                    project.update()
                "
                class="flex-none"
            />
        </div>
    </div>
</div>

</template>

<script lang='ts'>

import { Component, Prop, Vue } from 'vue-property-decorator';
import { State } from 'vuex-class';

import { colors } from '@/ts/data/enums';
import { Project } from '@/ts/project';

import IconBase from '@/components/IconBase.vue';
import ButtonColor from './ButtonColor.vue';

@Component({
    components: {
        ButtonColor,
        IconBase,
    },
})
export default class C extends Vue {
    @State('project')
    private project!: Project;

    @Prop()
    private colorName!: string;

    private readonly PALETTE = [
        colors.blue,
        colors.green,
        colors.yellow,
        colors.orange,
        colors.red,
        colors.purple,
        colors.grey,
        colors.white,
    ];

    private showPalette: boolean = false;
}

</script>
